SystemOrganization addCategory: #'Mabinogi-Core'!
SystemOrganization addCategory: #'Mabinogi-Core-Persistence'!
SystemOrganization addCategory: #'Mabinogi-Core-Commands'!

Trait named: #TMbObject
	uses: {}
	category: 'Mabinogi-Core'!

!TMbObject classSide methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:59'!
findFieldsPragma
	| currentClass pragma |
	pragma := nil.
	currentClass := self.
	[ pragma isNil and: [currentClass isMabinogiClass] ] whileTrue: [
		pragma := (currentClass methods detect: [ :m | (m pragmaAt: self mbDefinitionPragma) notNil ] ifNone: [nil])
			ifNotNil: [ :m | m pragmaAt: self mbDefinitionPragma].
		currentClass := currentClass superclass].
	^pragma! !

!TMbObject classSide methodsFor: 'testing' stamp: 'StuartHerring 4/1/2012 18:00'!
isMabinogiClass
	^true! !

!TMbObject classSide methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:51'!
mbDefinitionFor: aField
	^(self mbSelectors includes: aField)
		ifFalse: [ nil ]
		ifTrue: [
			(self lookupSelector: aField) ifNotNil: [ :method |
				method pragmas
					inject: (MbDefinition selector: aField)
					into: [ :def :p | 
						[ 
						p numArgs > 0
							ifTrue: [ p sendTo: def ]
							ifFalse: [ def perform: p keyword asMutator with: true ] ]
							on: MessageNotUnderstood
							do: [ :err |  ].	"Assume unknown pragmas aren't for us"
						def ignored ifTrue: [nil] ifFalse: [def]] ]
				ifNil: [nil]]! !

!TMbObject classSide methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:51'!
mbDefinitionPragma
	^#mbFields:! !

!TMbObject classSide methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:51'!
mbDefinitions
	^(self mbSelectors)
		collect: [ :s | self mbDefinitionFor: s ] 
		thenSelect: [ :def | def notNil]! !

!TMbObject classSide methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:51'!
mbSelectors
	^self findFieldsPragma 
		ifNil: [#()]
		ifNotNil: [ :p | p arguments first]
! !

!TMbObject methodsFor: 'testing' stamp: 'StuartHerring 4/1/2012 17:48'!
isEmptyOrNil
	^false! !

!TMbObject methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:48'!
mbDefinitionFor: aSelector
	^(self class mbDefinitionFor: aSelector)
		ifNotNil: [ :d | d setModel: self ]! !

!TMbObject methodsFor: 'mabinogi-private' stamp: 'StuartHerring 4/1/2012 17:58'!
mbDefinitions
	^(self class mbDefinitions)
		collect: [ :s | s setModel: self ] ! !

!TMbObject methodsFor: 'accessing' stamp: 'StuartHerring 6/11/2012 20:21'!
set: aField to: aValue
	(self class mbDefinitionFor: aField) 
		ifNotNil: [ :def | def 
			setModel: self;
			assertValid: aValue].
	self instVarNamed: aField put: aValue.! !

!TMbObject methodsFor: 'testing' stamp: 'StuartHerring 6/4/2012 19:38'!
typeDescription
	^self printString! !

!Class methodsFor: '*mabinogi-core' stamp: 'StuartHerring 4/1/2012 18:00'!
isMabinogiClass
	^false! !

Object subclass: #MbCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbCommand methodsFor: 'testing' stamp: 'StuartHerring 1/22/2012 13:53'!
canUndo
	"Indicates whether or not this command can be undone"
	^true! !

!MbCommand methodsFor: 'accessing' stamp: 'StuartHerring 1/22/2012 16:10'!
description
	^self class name! !

!MbCommand methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 13:46'!
do
	"Performs the action"! !

!MbCommand methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 13:46'!
undo
	"Restore the model to its previous state"! !

MbCommand subclass: #MbSimpleCommand
	instanceVariableNames: 'doBlock undoBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbSimpleCommand class methodsFor: 'instance creation' stamp: 'StuartHerring 1/22/2012 14:08'!
do: aBlock
	^self do: aBlock undo: nil! !

!MbSimpleCommand class methodsFor: 'instance creation' stamp: 'StuartHerring 1/22/2012 13:52'!
do: aDoBlock undo: anUndoBlock
	^self basicNew
		initializeWithDo: aDoBlock undo: anUndoBlock;
		yourself! !

!MbSimpleCommand methodsFor: 'testing' stamp: 'StuartHerring 1/22/2012 13:54'!
canUndo
	^undoBlock notNil! !

!MbSimpleCommand methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 13:53'!
do
	doBlock value! !

!MbSimpleCommand methodsFor: 'initialization' stamp: 'StuartHerring 1/22/2012 13:53'!
initializeWithDo: aDoBlock undo: anUndoBlock
	self initialize.
	doBlock := aDoBlock.
	undoBlock := anUndoBlock! !

!MbSimpleCommand methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 13:53'!
undo
	undoBlock value! !

MbCommand subclass: #MbUpdateDefinedObjectCommand
	instanceVariableNames: 'oldValues newValues object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbUpdateDefinedObjectCommand class methodsFor: 'instance creation' stamp: 'StuartHerring 2/15/2012 18:59'!
object: anObject newValues: anObjectOrDictionary
	^self basicNew
		initializeWithObject: anObject newValues: anObjectOrDictionary;
		yourself! !

!MbUpdateDefinedObjectCommand methodsFor: 'actions' stamp: 'StuartHerring 2/15/2012 19:05'!
do
	newValues keysAndValuesDo: [ :k :v |  object perform: (k asMutator) with: v]! !

!MbUpdateDefinedObjectCommand methodsFor: 'initialization' stamp: 'StuartHerring 2/15/2012 19:37'!
initializeWithObject: anObject newValues: anObjectOrDictionary
	self initialize.
	object := anObject.
	oldValues := (anObject mbDefinitions collect: [ :def | 
		def selector -> def modelValue ]) asDictionary.
	 newValues :=  (oldValues keys collect: (anObjectOrDictionary isDictionary 
		ifTrue: [ [ :k | k ->anObjectOrDictionary at: k]]
		ifFalse: [ [ :k | k-> (anObjectOrDictionary perform: k) ]])) asDictionary.
	! !

!MbUpdateDefinedObjectCommand methodsFor: 'actions' stamp: 'StuartHerring 6/4/2012 19:38'!
name
	^'Update ', object typeDescription! !

!MbUpdateDefinedObjectCommand methodsFor: 'actions' stamp: 'StuartHerring 6/4/2012 19:39'!
printOn: aStream
	aStream 
		nextPutAll: 'Updated ';
		nextPutAll: object typeDescription
		! !

!MbUpdateDefinedObjectCommand methodsFor: 'actions' stamp: 'StuartHerring 2/15/2012 19:05'!
undo
	oldValues keysAndValuesDo: [ :k :v |  object perform: (k asMutator) with: v]! !

Object subclass: #MbCommandProcessor
	instanceVariableNames: 'history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Commands'!

!MbCommandProcessor methodsFor: 'testing' stamp: 'StuartHerring 1/22/2012 15:52'!
canUndo
	^history notEmpty! !

!MbCommandProcessor methodsFor: 'accessing' stamp: 'StuartHerring 1/22/2012 15:53'!
history
	^history! !

!MbCommandProcessor methodsFor: 'accessing' stamp: 'StuartHerring 2/5/2012 17:37'!
history: aCollection
	"Replace the internal history collection with an external one"
	history := aCollection.! !

!MbCommandProcessor methodsFor: 'initialization' stamp: 'StuartHerring 1/22/2012 15:54'!
initialize
	super initialize.
	history := OrderedCollection new.! !

!MbCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 2/5/2012 17:08'!
invoke: aCommand
	aCommand do.
	history addFirst: aCommand
! !

!MbCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 21:20'!
undo
	history removeFirst
		undo! !

MbCommandProcessor subclass: #MbTransactionalCommandProcessor
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

!MbTransactionalCommandProcessor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:13'!
transactionProvider: aTransactionProvider
	^self basicNew
		initializeWithTransactionProvider: aTransactionProvider;
		yourself.! !

!MbTransactionalCommandProcessor methodsFor: 'initialization' stamp: 'StuartHerring 5/21/2012 20:56'!
initializeWithTransactionProvider: aTransactionProvider
	self initialize.
	transactionProvider := aTransactionProvider! !

!MbTransactionalCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 3/11/2012 12:28'!
invoke: aCommand
	transactionProvider commit: [
		super invoke: aCommand ].! !

!MbTransactionalCommandProcessor methodsFor: 'actions' stamp: 'StuartHerring 2/5/2012 17:09'!
undo
	transactionProvider commit: [ super undo ]! !

Object subclass: #MbDefinition
	instanceVariableNames: 'label required formatter rules selector model typeHint renderHint valuesBlock precision currency ignored readOnly embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbDefinition commentStamp: 'StuartHerring 5/21/2012 21:00' prior: 0!
I represent the definition of a field within an object and present the additional meta-information required to enable automatic validation and presentation of the field.!

!MbDefinition class methodsFor: 'instance creation' stamp: 'StuartHerring 1/10/2012 18:34'!
selector: aSelector 
	^self basicNew
		initializeWithSelector: aSelector;
		yourself! !

!MbDefinition methodsFor: 'validation' stamp: 'StuartHerring 4/1/2012 15:51'!
assertValid: aValue
	required ifTrue: [ (MbRequiredRule definition: self) assertValid: aValue ].
		aValue ifNotNil: [ rules do: [ :r | r assertValid: aValue ]]! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:21'!
currency 
	^currency! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 2/13/2012 20:15'!
currency: aCurrencySymbol
	currency := aCurrencySymbol.
	formatter := [ :v | '{1} {2}' format: {aCurrencySymbol asString. v printAsCurrency}].
	self numeric: 2! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 5/21/2012 20:57'!
date: aBoolean
	aBoolean
		ifFalse: [ ^ self ].
	self typeHint: #date.
	rules
		add:
			(MbRule
				validationBlock: [ :v | 
					[ v asDate ]
						on: Error
						do: [ :err | MbInvalidFormatError signal ] ]).
	self renderHint: #datePicker! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 3/6/2012 14:28'!
embed: anIgnoredBoolean
	embedded := true.! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 3/6/2012 14:28'!
embedded
	^embedded! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 2/12/2012 19:42'!
ignore: aValue
	ignored := true! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:42'!
ignored
	^ignored! !

!MbDefinition methodsFor: 'initialization' stamp: 'StuartHerring 3/6/2012 14:28'!
initializeWithSelector: aSelector
	self initialize.
	selector := aSelector.
	label := aSelector asCapitalizedPhrase.
	required := false.
	rules := OrderedCollection new.
	typeHint := #string.
	precision := nil.
	ignored := false.
	formatter := [ :v | v asString ].
	readOnly := false.
	embedded := false.! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 3/4/2012 17:51'!
integer: dummy
	self numeric: 0! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/11/2012 10:32'!
label
	^label! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 1/12/2012 16:55'!
label: aLabel
	label := aLabel! !

!MbDefinition methodsFor: 'model-accessing' stamp: 'StuartHerring 2/13/2012 20:05'!
modelValue
	^model perform: selector! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 4/1/2012 15:40'!
numeric: aBooleanOrNumber
	self typeHint: #numeric.
	rules add: (MbRule validationBlock: [ :v | [v asNumber] on: Error do: [ :err | MbInvalidFormatError signal ] ]).
	aBooleanOrNumber isNumber ifTrue: [
		precision := aBooleanOrNumber].! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 4/1/2012 15:01'!
password: anIgnoredValue
	self renderHint: #password.
	rules add: (MbMinimumLengthRule length: 8)! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:18'!
precision
	^precision! !

!MbDefinition methodsFor: 'printing' stamp: 'StuartHerring 3/3/2012 22:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self selector.
	aStream nextPut: $).! !

!MbDefinition methodsFor: 'printing' stamp: 'StuartHerring 2/13/2012 20:14'!
printValue
	^formatter value: self modelValue! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 2/15/2012 19:25'!
readOnly
	^readOnly! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 2/15/2012 19:24'!
readOnly: boolean
	readOnly := boolean.! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint
	^renderHint! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint: aSymbol
	renderHint := aSymbol! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/10/2012 18:36'!
required
	^required! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 1/10/2012 18:39'!
required: aBoolean
	required := aBoolean.! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/10/2012 18:38'!
selector
	^selector! !

!MbDefinition methodsFor: 'model-accessing' stamp: 'StuartHerring 1/29/2012 08:30'!
setModel: anObject
	model := anObject! !

!MbDefinition methodsFor: 'model-accessing' stamp: 'StuartHerring 2/1/2012 20:09'!
setModelValue: aValue
	model perform: selector asMutator with: aValue! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint
	^typeHint! !

!MbDefinition methodsFor: 'pragmas' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint: aSymbol
	typeHint := aSymbol! !

!MbDefinition methodsFor: 'validation' stamp: 'StuartHerring 4/1/2012 15:23'!
validateWith: aSymbol
	rules add: (MbRule validationBlock: [ :value | model perform: aSymbol with: value])! !

!MbDefinition methodsFor: 'model-accessing' stamp: 'StuartHerring 1/30/2012 19:07'!
valueSelector: aSymbol
	valuesBlock := [model perform: aSymbol].
	rules add: (MbRestrictedValueRule valuesBlock: valuesBlock).
	self renderHint: #dropDown! !

!MbDefinition methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 19:07'!
values
	^valuesBlock value! !

Object subclass: #MbObject
	uses: TMbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbObject class
	uses: TMbObject classTrait
	instanceVariableNames: ''!

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:55'!
new
	^self basicNew
		initialize! !

Object subclass: #MbRule
	instanceVariableNames: 'validationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbRule subclass: #MbMinimumLengthRule
	instanceVariableNames: 'length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbMinimumLengthRule class methodsFor: 'instance creation' stamp: 'StuartHerring 4/1/2012 15:08'!
length: aNumber
	^self validationBlock: [ :value | (value notNil and: [value size  < aNumber]) 
		ifTrue: [ MbMinimumLengthError signalForLength: aNumber  ]]! !

MbRule subclass: #MbRequiredRule
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredRule class methodsFor: 'instance creation' stamp: 'StuartHerring 3/18/2012 10:05'!
definition: aDefinition
	^self basicNew
		initializeWithDefinition: aDefinition;
		yourself.! !

!MbRequiredRule class methodsFor: 'instance creation' stamp: 'StuartHerring 3/18/2012 10:05'!
new
	self shouldNotImplement! !

!MbRequiredRule methodsFor: 'initialization' stamp: 'StuartHerring 3/18/2012 10:05'!
initializeWithDefinition: aDefinition
	self initialize.
	definition := aDefinition.
	validationBlock := [ :aValue |
			(aValue isNil or: [ aValue isCollection and: [ aValue isEmpty]]) ifTrue: [ MbRequiredFieldError signal: 'Field ', aDefinition label, ' is required' ]]! !

MbRule subclass: #MbRestrictedValueRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRestrictedValueRule class methodsFor: 'instance creation' stamp: 'StuartHerring 2/6/2012 22:05'!
valuesBlock: valuesBlock
	^self validationBlock: [ :aValue |
	(valuesBlock value includes: aValue) ifFalse: [ MbValidationError signal ]]! !

!MbRule class methodsFor: 'instance creation' stamp: 'StuartHerring 2/6/2012 22:02'!
validationBlock: aBlock
	^self basicNew
		initializeWithBlock: aBlock;
		yourself! !

!MbRule methodsFor: 'validation' stamp: 'StuartHerring 2/6/2012 22:01'!
assertValid: aValue
	validationBlock value: aValue.! !

!MbRule methodsFor: 'initialization' stamp: 'StuartHerring 2/6/2012 22:02'!
initializeWithBlock: aBlock
	self initialize.
	validationBlock := aBlock.! !

Object subclass: #MbTransactionProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

MbTransactionProvider subclass: #MbMagmaTransactionProvider
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

!MbMagmaTransactionProvider class methodsFor: 'instance creation' stamp: 'StuartHerring 2/23/2012 14:30'!
localAt: aByteString 
	^self basicNew
		initializeWithLocation: (MagmaLocalLocation path: aByteString);
		yourself! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 14:35'!
begin
	magmaSession begin.! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 14:36'!
close
	magmaSession disconnectAndClose.
	magmaSession := nil.! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 14:35'!
commit
	magmaSession commit.! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 3/12/2012 19:34'!
commit: aBlock
	magmaSession commit: aBlock! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 4/8/2012 12:26'!
commitForUpgrade: aBlock
	[ magmaSession commit: aBlock ] on: MagmaTruncationWarning
		do: [ :w | w resume ]! !

!MbMagmaTransactionProvider methodsFor: 'initialization' stamp: 'StuartHerring 2/23/2012 14:34'!
initializeWithLocation: aMagmaLocalLocation 
	self initialize.
	magmaSession := aMagmaLocalLocation newSession.
	magmaSession connectAs: self class name.! !

!MbMagmaTransactionProvider methodsFor: 'initialization' stamp: 'StuartHerring 3/18/2012 13:32'!
magmaSession
	^magmaSession! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 14:36'!
rollback
	magmaSession abort.! !

!MbMagmaTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 14:31'!
root
	^magmaSession root.! !

MbTransactionProvider subclass: #MbMemoryTransactionProvider
	instanceVariableNames: 'root'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Mabinogi-Core-Persistence'!

!MbMemoryTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:16'!
default
	^Default ifNil: [ Default := self new]! !

!MbMemoryTransactionProvider methodsFor: 'initialization' stamp: 'StuartHerring 3/17/2012 16:12'!
initialize
	super initialize.
	root := Dictionary new.! !

!MbMemoryTransactionProvider methodsFor: 'accessing' stamp: 'StuartHerring 3/17/2012 16:18'!
root
	^root! !

!MbTransactionProvider methodsFor: 'transactions' stamp: 'StuartHerring 2/4/2012 14:16'!
begin
! !

!MbTransactionProvider methodsFor: 'initialize-release' stamp: 'StuartHerring 2/23/2012 14:36'!
close
	"Close the provider"! !

!MbTransactionProvider methodsFor: 'transactions' stamp: 'StuartHerring 2/4/2012 14:16'!
commit
! !

!MbTransactionProvider methodsFor: 'transactions' stamp: 'StuartHerring 3/11/2012 12:28'!
commit: aBlock
	self begin.
	[ aBlock value. self commit ] 
		on: Error do: [ :e | self rollback. e signal	].
! !

!MbTransactionProvider methodsFor: 'transactions' stamp: 'StuartHerring 4/8/2012 12:22'!
commitForUpgrade: aBlock
"Allow special handling if the transaction is part of a schema upgrade process"
	self commit: aBlock! !

!MbTransactionProvider methodsFor: 'transactions' stamp: 'StuartHerring 2/4/2012 14:16'!
rollback! !

Error subclass: #MbValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbValidationError subclass: #MbInvalidFormatError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbInvalidFormatError class methodsFor: 'exceptioninstantiator' stamp: 'StuartHerring 5/21/2012 19:05'!
signal
	self signal: 'invalid format'! !

MbValidationError subclass: #MbMinimumLengthError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbMinimumLengthError class methodsFor: 'exceptioninstantiator' stamp: 'StuartHerring 4/1/2012 15:50'!
signalForLength: aNumber
	self signal: ('Must be at least {1} characters' format: {aNumber})! !

MbValidationError subclass: #MbRequiredFieldError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredFieldError class methodsFor: 'exceptioninstantiator' stamp: 'StuartHerring 4/1/2012 15:50'!
signal
	self signal: 'required'! !
